      program make_hex
c     draw plane of hexagons
      
      open(unit=10,file='hex-field.cmod')

      call write_header

      dx = 0.866025448

      d2r = 3.14159265/180.0
      dy = 1.0+ sin(30.0*d2r)
c      print *, dy

c     row 1: skip 3, draw 4
c     row 2: skip 1, draw 7
c     row 3: skip 1, draw 8
c     rows 4: draw 9
c     rows 5: draw 10
c     rows 6: draw 9
c     rows 7: draw 10
c     rows 8: draw 9
c     row 9: skip 1, draw 8
c     row 10: skip 1, draw 7
c     row 11: skip 3, draw 4
      
c     row 1: skip 3, draw 4
         x0 = 0 + 3*2*dx
         y0 = 0
         n=4
         call write_hex_row (n,x0,y0)

c     row 2: skip 1, draw 7
         x0 = dx + 2*dx
         y0 = y0+ dy
         n=7
         call write_hex_row (n,x0,y0)

c     row 3: skip 1, draw 8
         x0 = 0 + 2*dx
         y0 = y0+ dy
         n=8
         call write_hex_row (n,x0,y0)

c     rows 4: draw 9
         x0 = dx
         y0 = y0+ dy
         n=9
         call write_hex_row (n,x0,y0)

c     rows 5: draw 10
         x0 = 0 
         y0 = y0+ dy
         n=10
         call write_hex_row (n,x0,y0)

c     rows 6: draw 9
         x0 = dx
         y0 = y0+ dy
         n=9
         call write_hex_row (n,x0,y0)

c     rows 7: draw 10
         x0 = 0 
         y0 = y0+ dy
         n=10
         call write_hex_row (n,x0,y0)

c     rows 8: draw 9
         x0 = dx
         y0 = y0+ dy
         n=9
         call write_hex_row (n,x0,y0)

c     row 9: skip 1, draw 8
         x0 = 0 + 2*dx
         y0 = y0+ dy
         n=8
         call write_hex_row (n,x0,y0)

c     row 10: skip 1, draw 7
         x0 = dx + 2*dx
         y0 = y0+ dy
         n=7
         call write_hex_row (n,x0,y0)

c     row 11: skip 3, draw 4
         x0 = 0 + 3*2*dx
         y0 = y0+ dy
         n=4
         call write_hex_row (n,x0,y0)

      stop
      
      end
c=============================
      subroutine write_hex_row (n,x0,y0)
      integer nrow
      data nrow/0/
      save nrow
      nrow=nrow+1
        
      d2r = 3.14159265/180.0
      dx = 2.0*0.866025448 

      h = -0.3
      h = h + 0.2
         
      write(10,*) 'mesh # 6 sided figure'
      write(10,*)
     * 'vertexdesc'
      write(10,*)
     * '  position f3'
      write(10,*)
     * 'end_vertexdesc'

      write(10,*)
     * 'vertices   ',6*n*2

c     define 1st layer of hexes
      do nhex = 0,n-1
!     one hex
         do nr = 0,5
            th = nr * 60.0 - 30.0
            write(10,*)x0+nhex*dx+cos(th*d2r), y0+sin(th*d2r),h
c     *           ,'#',nrow,nhex,nr
         enddo
      enddo
        h = h + 0.2
      
c     define 2nd layer of hexes
      do nhex = 0,n-1
!     one hex
         do nr = 0,5
            th = nr * 60.0 - 30.0
            write(10,*)x0+nhex*dx+cos(th*d2r), y0+sin(th*d2r),h
c     *           ,'#',nrow,nhex,nr
         enddo
      enddo


c     draw outlines of 1st layer of hexes
      do nhex = 0,(n-1)
         n0 = nhex*6
         write(10,*) 'linestrip 1',7
         write(10,*) (n0+i,i=0,5), n0
         nlast = nhex
      enddo

c     draw outlines of 2nd layer of hexes
      do nhex = nlast+1,nlast+1+(n-1)
         n0 = nhex*6
         write(10,*) 'linestrip 0',7
         write(10,*) (n0+i,i=0,5), n0
      enddo
      
c     draw vertical lines between layers

      nh = nlast
      do nhex = 0,(n-1)
         n0 = nhex*6
         nh = nh +1
         n1 = nh*6
         write(10,*) 'linelist 1',12
         write(10,*) (n0+i,n1+i,i=0,5)
      enddo

      write(10,*) ' end_mesh'

      return
      end
      
c=============================
      subroutine write_header
      write(10,fmt='(a)')
     * '#celmodel__ascii'

      write(10,*) 
     * '# hex grid for Celestia v1.6.1'
      write(10,*)
     * '# s.ball 04jan2018'

      write(10,*)
     * 'material		# 0 = hex grid'
      write(10,*)
     * '  emissive 0.3 0.8 0.3'
      write(10,*)
     * '  diffuse  0.3 0.8 0.3'
      write(10,*)
     * '  opacity 1'
      write(10,*)
     * 'end_material'

      write(10,*)
     * 'material		# 1 = 2nd layer of (dimmer) hex grid'
      write(10,*)
     * '  emissive 0.3 0.5 0.3'
      write(10,*)
     * '  diffuse  0.3 0.5 0.3'
      write(10,*)
     * '  opacity 1'
      write(10,*)
     * 'end_material'



      return
      end
