      program radial_graticule

      open(unit=10,file='radial_graticule.cmod')

      call write_header
      do nr = 1,25
         r = nr
         call write_circle(r)
      enddo

      call write_spokes(25.2)
      call write_00 (25.2)
      call write_tics (10.1)
      call write_tics (15.1)
      call write_tics (20.1)
      call write_tics (25.0)
      
      end
c=============================
      subroutine write_header
      write(10,fmt='(a)')
     * '#celmodel__ascii'

      write(10,*) 
     * '# cmod radial graticule for Celestia v1.6.1'
      write(10,*)
     * '# s.ball 03jan2018'

      write(10,*)
     * 'material		# 0 = grid and circles'
      write(10,*)
     * 'emissive 0.3 0.3 0.3'
      write(10,*)
     * 'diffuse  0.3 0.3 0.3'
      write(10,*)
     * 'opacity 1'
      write(10,*)
     * 'end_material'

      write(10,*)
     * 'material		# 1 = arrow pointing toward origin (x axis)'
      write(10,*)
     * 'emissive 1 0 0'
      write(10,*)
     * 'diffuse  1 0 0'
      write(10,*)
     * 'opacity 1'
      write(10,*)
     * 'end_material'

      write(10,*)
     * 'material		# 2 = 5 & 10 degree fiducials'
      write(10,*)
     * 'emissive  0.5 0.5 0.5'
      write(10,*)
     * 'diffuse   0.5 0.5 0.5'
      write(10,*)
     * 'opacity 1'
      write(10,*)
     * 'end_material'


      return
      end
      
c=============================
      subroutine write_tics(r)
      d2r = 3.14159265/180.0

      write(10,*) ' '
      write(10,*)
     * 'mesh'

      write(10,*) '# 360 tics'
      write(10,*)
     * 'vertexdesc'
      write(10,*)
     * 'position f3'
      write(10,*)
     * 'end_vertexdesc'

      write(10,*)
     * 'vertices   ',360*2

      do nr = 0,359
         write(10,*) (r-0.2)*cos(float(nr)*d2r),
     *        (r-0.2)*sin(float(nr)*d2r),0
         write(10,*) r*cos(float(nr)*d2r),r*sin(float(nr)*d2r),0
      enddo

      write(10,*) 'linelist 0',360*2
      do nr = 0,359
         write(10,*) nr*2,1+nr*2
      enddo

      write(10,*) ' end_mesh'
      
      return
      end
c=============================
      subroutine write_spokes(r)
      d2r = 3.14159265/180.0
      write(10,*) ' '
      write(10,*)
     * 'mesh'

      write(10,*) '# 360/5 spokes'
      write(10,*)
     * 'vertexdesc'
      write(10,*)
     * 'position f3'
      write(10,*)
     * 'end_vertexdesc'

      write(10,*)
     * 'vertices   ',2*(360/5)
c     * 'vertices   ',360/5+1

c      write(10,*) 0,0,0

      ns = 0
      do nr = 0,358,5
         write(10,*) 0.9*cos(float(nr)*d2r),0.9*sin(float(nr)*d2r),0
         write(10,*) r*cos(float(nr)*d2r),r*sin(float(nr)*d2r),0
         ns = ns+2
      enddo

      write(10,*) 'linelist 0', ns -2
      do nr = 2,ns-2,2
         write(10,*) nr,nr+1
      enddo

      write(10,*) ' end_mesh'
      
      return
      end
c=============================
      subroutine write_00(r)
      d2r = 3.14159265/180.0
      write(10,*) ' '
      write(10,*)
     * 'mesh'

      write(10,*) '# 00'
      write(10,*)
     * 'vertexdesc'
      write(10,*)
     * 'position f3'
      write(10,*)
     * 'end_vertexdesc'

      write(10,*)
     * 'vertices   ',2
      write(10,*) 0,0,0
      write(10,*) r,0,0
c      write(10,*) 0,0,0
c      write(10,*) r,0,0

      write(10,*) 'linelist 1',2
         write(10,*) 0,1

      write(10,*) ' end_mesh'
      
      return
      end
c=============================
      subroutine write_circle(r)
      nv = 360
      d2r = 3.14159265/180.0


      write(10,*) ' '
      write(10,*)
     * 'mesh'

      write(10,*) '# circle',r
      write(10,*)
     * 'vertexdesc'
      write(10,*)
     * 'position f3'
      write(10,*)
     * 'end_vertexdesc'

      write(10,*)
     * 'vertices   ',nv

      do nr = 1,nv
         write(10,*) r*cos(float(nr)*d2r),r*sin(float(nr)*d2r),0
      enddo
      write(10,*) 'linestrip 0',nv+1
      do nr = 0,nv-1,4
         write(10,*) nr,nr+1,nr+2,nr+3
      enddo
      write(10,*) 0
      write(10,*) ' end_mesh'
      
      return
      end
